package com.hfkj.dao;

import com.hfkj.entity.BsAudit;
import com.hfkj.entity.BsAuditExample.Criteria;
import com.hfkj.entity.BsAuditExample.Criterion;
import com.hfkj.entity.BsAuditExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsAuditSqlProvider {

    public String countByExample(BsAuditExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_audit");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsAuditExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_audit");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsAudit record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_audit");
        
        if (record.getAuditNo() != null) {
            sql.VALUES("audit_no", "#{auditNo,jdbcType=VARCHAR}");
        }
        
        if (record.getVocationalWorkType() != null) {
            sql.VALUES("vocational_work_type", "#{vocationalWorkType,jdbcType=INTEGER}");
        }
        
        if (record.getVocationalWorkTypeName() != null) {
            sql.VALUES("vocational_work_type_name", "#{vocationalWorkTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getAuditObjectId() != null) {
            sql.VALUES("audit_object_id", "#{auditObjectId,jdbcType=BIGINT}");
        }
        
        if (record.getAuditObjectName() != null) {
            sql.VALUES("audit_object_name", "#{auditObjectName,jdbcType=VARCHAR}");
        }
        
        if (record.getOpUserId() != null) {
            sql.VALUES("op_user_id", "#{opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.VALUES("op_user_name", "#{opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getReviewedUserId() != null) {
            sql.VALUES("reviewed_user_id", "#{reviewedUserId,jdbcType=BIGINT}");
        }
        
        if (record.getReviewedUserName() != null) {
            sql.VALUES("reviewed_user_name", "#{reviewedUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getRejectReason() != null) {
            sql.VALUES("reject_reason", "#{rejectReason,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsAuditExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("audit_no");
        sql.SELECT("vocational_work_type");
        sql.SELECT("vocational_work_type_name");
        sql.SELECT("audit_object_id");
        sql.SELECT("audit_object_name");
        sql.SELECT("op_user_id");
        sql.SELECT("op_user_name");
        sql.SELECT("reviewed_user_id");
        sql.SELECT("reviewed_user_name");
        sql.SELECT("`status`");
        sql.SELECT("reject_reason");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_audit");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsAudit record = (BsAudit) parameter.get("record");
        BsAuditExample example = (BsAuditExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_audit");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getAuditNo() != null) {
            sql.SET("audit_no = #{record.auditNo,jdbcType=VARCHAR}");
        }
        
        if (record.getVocationalWorkType() != null) {
            sql.SET("vocational_work_type = #{record.vocationalWorkType,jdbcType=INTEGER}");
        }
        
        if (record.getVocationalWorkTypeName() != null) {
            sql.SET("vocational_work_type_name = #{record.vocationalWorkTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getAuditObjectId() != null) {
            sql.SET("audit_object_id = #{record.auditObjectId,jdbcType=BIGINT}");
        }
        
        if (record.getAuditObjectName() != null) {
            sql.SET("audit_object_name = #{record.auditObjectName,jdbcType=VARCHAR}");
        }
        
        if (record.getOpUserId() != null) {
            sql.SET("op_user_id = #{record.opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.SET("op_user_name = #{record.opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getReviewedUserId() != null) {
            sql.SET("reviewed_user_id = #{record.reviewedUserId,jdbcType=BIGINT}");
        }
        
        if (record.getReviewedUserName() != null) {
            sql.SET("reviewed_user_name = #{record.reviewedUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getRejectReason() != null) {
            sql.SET("reject_reason = #{record.rejectReason,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_audit");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("audit_no = #{record.auditNo,jdbcType=VARCHAR}");
        sql.SET("vocational_work_type = #{record.vocationalWorkType,jdbcType=INTEGER}");
        sql.SET("vocational_work_type_name = #{record.vocationalWorkTypeName,jdbcType=VARCHAR}");
        sql.SET("audit_object_id = #{record.auditObjectId,jdbcType=BIGINT}");
        sql.SET("audit_object_name = #{record.auditObjectName,jdbcType=VARCHAR}");
        sql.SET("op_user_id = #{record.opUserId,jdbcType=BIGINT}");
        sql.SET("op_user_name = #{record.opUserName,jdbcType=VARCHAR}");
        sql.SET("reviewed_user_id = #{record.reviewedUserId,jdbcType=BIGINT}");
        sql.SET("reviewed_user_name = #{record.reviewedUserName,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("reject_reason = #{record.rejectReason,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsAuditExample example = (BsAuditExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsAudit record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_audit");
        
        if (record.getAuditNo() != null) {
            sql.SET("audit_no = #{auditNo,jdbcType=VARCHAR}");
        }
        
        if (record.getVocationalWorkType() != null) {
            sql.SET("vocational_work_type = #{vocationalWorkType,jdbcType=INTEGER}");
        }
        
        if (record.getVocationalWorkTypeName() != null) {
            sql.SET("vocational_work_type_name = #{vocationalWorkTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getAuditObjectId() != null) {
            sql.SET("audit_object_id = #{auditObjectId,jdbcType=BIGINT}");
        }
        
        if (record.getAuditObjectName() != null) {
            sql.SET("audit_object_name = #{auditObjectName,jdbcType=VARCHAR}");
        }
        
        if (record.getOpUserId() != null) {
            sql.SET("op_user_id = #{opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.SET("op_user_name = #{opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getReviewedUserId() != null) {
            sql.SET("reviewed_user_id = #{reviewedUserId,jdbcType=BIGINT}");
        }
        
        if (record.getReviewedUserName() != null) {
            sql.SET("reviewed_user_name = #{reviewedUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getRejectReason() != null) {
            sql.SET("reject_reason = #{rejectReason,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsAuditExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}